//	PinballMode.cpp - Tanks bounce all over the place.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "PinballMode.h"
#include "GamePlayState.h"
#include "Tank.h"

//------------------------------------------------------------------------------
PinballMode::PinballMode()
{

}

//------------------------------------------------------------------------------
PinballMode::~PinballMode()
{

}

//------------------------------------------------------------------------------
void PinballMode::collide(Tank& tank,
						  GamePlayState& state,
						  const shared_ptr<Collidable>& other)
{
	if((other->getName() == L"Wall") ||
	   (!tank.getNoRecoil() &&
		(other->getName() != L"Puddle") &&
		(other->getName() != L"Bee")))
	{
		TwoFloats tempDir(-sinf(tank.getAngle()), cosf(tank.getAngle()));
		TwoFloats mirrorVector((tank.getPosition() - other->getPosition()).normal());
		float angle = tempDir.getAngle(mirrorVector);

		//Make sure the angle isn't too shallow.
		if(angle > 0.8f)
		{
			float offset;
			const TwoFloats origin;
			float dist = origin.getDistance(mirrorVector);
			float rad = tank.getRadius() + other->getRadius();

			mirrorVector = mirrorVector.normal();
			offset = rad - dist;
			tempDir = mirrorVector * 12.0f;
		}
		else
			tempDir = tempDir.mirror(mirrorVector).normal() * 16.0f;

		tank.updateBounceVector(tempDir);
	}
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void PinballModeCreator::apply(GamePlayState& state)
{
	int i;

	for(i=0;i<state.getNumTanks();++i)
	{
		shared_ptr<TankCollisionModifier> mod(new PinballMode());

		state.getTank(i)->addCollisionModifier(mod);
	}
}
